<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// Development Started 03/22/2008
// $Id: utils-configwizards.inc.php 10 2009-11-14 21:07:09Z egalstad $

require_once(dirname(__FILE__).'/common.inc.php');



////////////////////////////////////////////////////////////////////////
//CONFIG WIZARD  FUNCTIONS
////////////////////////////////////////////////////////////////////////

function register_configwizard($name="",$args=null){
	global $configwizards;
	
	
	if($name=="")
		return false;
	
	if(!isset($configwizards)){
		$configwizards=array();
		}
	
	$configwizards[$name]=$args;
	
	return true;
	}


function get_configwizard_by_name($name=""){
	global $configwizards;
	
	$configwizard=null;

	if($name=="")
		return null;
		
	if(!array_key_exists($name,$configwizards))
		return null;
	$configwizard=$configwizards[$name];
		
	return $configwizard;
	}
	
function make_configwizard_callback($name="",$mode="",$inargs,&$outargs,&$result){
	
	// USE THIS FOR DEBUGGING!
	//return "<BR>NAME: $name, ID: $id, MODE: $mode, ARGS: ".serialize($args)."<BR>";
	
	$w=get_configwizard_by_name($name);
	if($w==null)
		return "";
		
	$output="";
		
	// run the  function
	if(array_key_exists(CONFIGWIZARD_FUNCTION,$w) && have_value($w[CONFIGWIZARD_FUNCTION])==true){
		$f=$w[CONFIGWIZARD_FUNCTION];
		if(function_exists($f))
			$output=$f($mode,$inargs,$outargs,$result);
		else
			$output="CONFIG WIZARD FUNCTION '".$f."' DOES NOT EXIST";
		}
	// nothing to do...
	else
		return $output;
		
	return $output;
	}

function clean_configwizard_request_vars(){
	global $request;
	
	// clear some request variables that shouldn't be passed to wizards
	$clear=array(
		//"nextstep",
		"update",
		"submitButton",
		"cancelButton",
		);
	foreach($clear as $c){
		if(array_key_exists($c,$request))
			unset($request[$c]);
		}
	}
?>